import 'package:flutter/material.dart';

extension MyString on String {
  ///
  int safeLength() => this == null ? -1 : this.length;

  ///
  String get toFirebaseSafeKey => this.replaceAll('.', ':').replaceAll('"\$"', ':').replaceAll('[', ':').replaceAll(']', ':').replaceAll('#', ':').replaceAll('/', ':').replaceAll('\\', ':').replaceAll('-', ':');

  ///
  bool get isEmail {
    Pattern pattern = r'^(([^<>()[\]\\.,;:\s@\"]+(\.[^<>()[\]\\.,;:\s@\"]+)*)|(\".+\"))@((\[[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\.[0-9]{1,3}\])|(([a-zA-Z\-0-9]+\.)+[a-zA-Z]{2,}))$';
    RegExp regex = new RegExp(pattern);
    return (!regex.hasMatch(this)) ? false : true;
  }

  Color get color => Color(int.parse('oxff${this}'));
}

extension MyObject on Object {
  void selfPrint([String name]) => print('***** ${name == null ? '' : name + ': '}$this *****');
}
